<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

/**
 * The name of this class is dependent on the component being installed.
 * The class name should have the component's name, directly followed by
 * the text InstallerScript (ex:. com_helloWorldInstallerScript).
 *
 * This class will be called by Joomla!'s installer, if specified in your component's
 * manifest file, and is used for custom automation actions in its installation process.
 *
 * In order to use this automation script, you should reference it in your component's
 * manifest file as follows:
 * <scriptfile>script.php</scriptfile>
 *
 * @package     Joomla.Administrator
 * @subpackage  sponsorswall
 *
 * @copyright   Copyright (C) 2005 - 2018 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */
class plgSystemAgmlibloaderInstallerScript
{
    /**
     * This method is called after a component is installed.
     *
     * @param  \stdClass $parent - Parent object calling this method.
     *
     * @return void
     */
    public function install($parent) 
    {
        //$parent->getParent()->setRedirectURL('index.php?option=com_sponsorswall');
    }

    /**
     * This method is called after a component is uninstalled.
     *
     * @param  \stdClass $parent - Parent object calling this method.
     *
     * @return void
     */
    public function uninstall($parent) 
    {
    }

    /**
     * This method is called after a component is updated.
     *
     * @param  \stdClass $parent - Parent object calling object.
     *
     * @return void
     */
    public function update($parent) 
    {
    }

    /**
     * Runs just before any installation action is preformed on the component.
     * Verifications and pre-requisites should run in this function.
     *
     * @param  string    $type   - Type of PreFlight action. Possible values are:
     *                           - * install
     *                           - * update
     *                           - * discover_install
     * @param  \stdClass $parent - Parent object calling object.
     *
     * @return void
     */
    public function preflight($type, $parent) 
    {
    }

    /**
     * Runs right after any installation action is preformed on the component.
     *
     * @param  string    $type   - Type of PostFlight action. Possible values are:
     *                           - * install
     *                           - * update
     *                           - * discover_install
     * @param  \stdClass $parent - Parent object calling object.
     *
     * @return void
     */
    function postflight($type, $parent) 
    {
		$db = JFactory::getDbo();
		// Versuche die extension_id zu laden
		$conditions = array(
			$db->quoteName('element') .' = '. $db->quote('agmlibloader')
		);

		$query  = $db->getQuery(true);
		$query  ->select($db->quoteName(array('extension_id')))
			->from($db->quoteName('#__extensions'))
			->where($conditions);
		$db->setQuery($query);
		$db->execute();
		$count = $db->getNumRows();
		$result = $db->loadAssoc();

		if ($count < 1) return true;

		// Create an object for the record we are going to update.
		$object = new stdClass();

		// Must be a valid primary key value.
		$object->extension_id = $result['extension_id'];
		$object->enabled = 1;

		// Update their details in the users table using id as the primary key.
		$result = JFactory::getDbo()->updateObject('#__extensions', $object, 'extension_id');
		return true;
    }
}